/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bonusgroupstrategy.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.guosen.bonusgroup.entity.BonusGroup;
import org.springblade.modules.guosen.bonusgroup.service.IBonusGroupService;
import org.springblade.modules.guosen.bonusgroup.vo.SimpleBonusGroupVO;
import org.springblade.modules.guosen.bonusgroupstrategy.vo.SimpleBonusGroupStrategyVO;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bonusgroupstrategy.entity.BonusGroupStrategy;
import org.springblade.modules.guosen.bonusgroupstrategy.vo.BonusGroupStrategyVO;
import org.springblade.modules.guosen.bonusgroupstrategy.wrapper.BonusGroupStrategyWrapper;
import org.springblade.modules.guosen.bonusgroupstrategy.service.IBonusGroupStrategyService;
import org.springblade.core.boot.ctrl.BladeController;

import java.math.BigDecimal;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 分润业务场景 控制器
 *
 * @author BladeX
 * @since 2021-11-13
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-bonus-group-strategy/bonusgroupstrategy")
@Api(value = "分润业务场景", tags = "分润业务场景接口")
public class BonusGroupStrategyController extends BladeController {

	private final IBonusGroupStrategyService bonusGroupStrategyService;
	private final IBonusGroupService bonusGroupService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bonusGroupStrategy")
	public R<BonusGroupStrategyVO> detail(BonusGroupStrategy bonusGroupStrategy) {
		BonusGroupStrategy detail = bonusGroupStrategyService.getOne(Condition.getQueryWrapper(bonusGroupStrategy));
		return R.data(BonusGroupStrategyWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 分润业务场景
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bonusGroupStrategy")
	public R<IPage<BonusGroupStrategyVO>> list(BonusGroupStrategy bonusGroupStrategy, Query query) {
		IPage<BonusGroupStrategy> pages = bonusGroupStrategyService.page(Condition.getPage(query), Condition.getQueryWrapper(bonusGroupStrategy));
		return R.data(BonusGroupStrategyWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 分润业务场景
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bonusGroupStrategy")
	public R<IPage<BonusGroupStrategyVO>> page(BonusGroupStrategyVO bonusGroupStrategy, Query query) {
		IPage<BonusGroupStrategyVO> pages = bonusGroupStrategyService.selectBonusGroupStrategyPage(Condition.getPage(query), bonusGroupStrategy);
		return R.data(pages);
	}

	/**
	 * 新增 分润业务场景
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bonusGroupStrategy")
	public R save(@Valid @RequestBody BonusGroupStrategy bonusGroupStrategy) {
		return R.status(bonusGroupStrategyService.save(bonusGroupStrategy));
	}

	/**
	 * 修改 分润业务场景
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bonusGroupStrategy")
	public R update(@Valid @RequestBody BonusGroupStrategy bonusGroupStrategy) {
		return R.status(bonusGroupStrategyService.updateById(bonusGroupStrategy));
	}

	/**
	 * 新增或修改 分润业务场景
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bonusGroupStrategy")
	public R submit(@Valid @RequestBody BonusGroupStrategy bonusGroupStrategy) {
		BigDecimal strategyRateStatic = this.bonusGroupStrategyService.strategyRateStatic(bonusGroupStrategy.getBonusSceneId(), bonusGroupStrategy.getBonusGroupId());
		BonusGroup group = this.bonusGroupService.getById(bonusGroupStrategy.getBonusGroupId());
		BigDecimal serviceRate = group.getServiceRate();
		if(bonusGroupStrategy.getRate() == null || (bonusGroupStrategy.getRate().compareTo(new BigDecimal(0)) == 0)){
			return R.fail("策略费率不能为0");
		}
		if(bonusGroupStrategy.getRate().compareTo(serviceRate) == 1){
			return R.fail("策略费率不能超过采购商服务费率");
		}
		int comp = (bonusGroupStrategy.getRate().add(strategyRateStatic)).compareTo(serviceRate);
		if( comp == 1){
			return R.fail("策略费率总和不能超过采购商服务费率");
		}
		return R.status(bonusGroupStrategyService.saveOrUpdate(bonusGroupStrategy));
	}

	
	/**
	 * 删除 分润业务场景
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(bonusGroupStrategyService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 根据条件下拉获取分润业务场景list
	 * @param strategy
	 * @return
	 */
	@GetMapping(value = "/listBonusGroupStrategy")
	@ApiOperationSupport(order = 8)
	public R<List<SimpleBonusGroupStrategyVO>> listBonusScene(BonusGroupStrategy strategy){
		LambdaQueryWrapper<BonusGroupStrategy> lambdaQueryWrapper = new LambdaQueryWrapper<>();
		if(StringUtil.isNotBlank(strategy.getStrategyName())){
			lambdaQueryWrapper.like(BonusGroupStrategy::getStrategyName, strategy.getStrategyName());
		}
		if(strategy.getBonusSceneId() != null){
			lambdaQueryWrapper.eq(BonusGroupStrategy::getBonusSceneId, strategy.getBonusSceneId());
		}
		if(strategy.getBonusGroupId() != null){
			lambdaQueryWrapper.eq(BonusGroupStrategy::getBonusGroupId, strategy.getBonusGroupId());
		}
		List<BonusGroupStrategy> list = this.bonusGroupStrategyService.list(lambdaQueryWrapper);
		List<SimpleBonusGroupStrategyVO> voList = list.stream()
						.map(item -> {
							SimpleBonusGroupStrategyVO vo = new SimpleBonusGroupStrategyVO();
							vo.setId(item.getId());
							vo.setName(item.getStrategyName());
							return vo;
						}).collect(Collectors.toList());
		return R.data(voList);
	}

	
}
